#ifndef CON_INOUT
#define CON_INOUT

#include <conio.h>
#include <inout.h>

class conout: public standardout
{
protected:
	conout( int w );
	static int X1, Y1, X2, Y2;
public:
	conout();
	~conout();

	void CC changecolor();
	char CC _put( char c );

	virtual void CC SetAttr( int f, int b );
		void CC SetAttr( unsigned c ) { SetAttr( c & 0x0f, c >> 4 ); }

	conout& Clear();
	conout& ClearEOL();
	static void Cursor();
	static void Cursor( byte start, byte end );
	static void NoCursor();
	static void Region( int x1, int y1, int x2, int y2 );
	static void NoRegion();
	static void GetRegion( int& x1, int& y1, int& x2, int& y2 );
	conout& GotoXY( int x, int y );
	static void ScrollUp( int lines );
	static void ScrollDown( int lines );
	int WhereX();
	int WhereY();
	int GetAttr();

	static void BIOSVideo();
	static void DirectVideo();
        static void SetVideoBorder( int c );
};

extern conout sout;

class conin: public standardin
{
private:
	conout& wout;
        int extendedkey;
public:
	conin( conout& wout = sout );
	~conin();

        void CC begininput();
        void CC endinput();

        int CC keyhit();
        char CC get();
        char CC out( char c );

        unsigned GetKey();
};

extern conin sin;
struct text_info;

class SaveScreen
{
	char* buf;
        text_info t;
protected:
	void save();
	void restore();
public:
	SaveScreen( int pr = 0 );
	~SaveScreen();
};

#endif

