#pragma hdrstop
#include <ctype.h>
#include <limits.h>
#include <string.h>
#include <stdlib.h>

#include "inout.h"

standardin::standardin()
{
        fieldwidth = 0;
        num_default = -1;
        num_max = -1;
}

char CC standardin::out( char c )
{
	return c;
}

void CC standardin::getstr( char *s )
{
	char ch,i=0;

	begininput();

	s[0] = 0;
        while(1)
        {
		ch = get();
		if( ch == '\t' )
			ch = ' ';

                if( ch == '\b' )
                {
                        if( i > 0 )
                        {
				i--;
				s[i]=0;
				out( '\b' );
				out( ' ' );
				out( '\b' );
			}
		}               
		else if( ch>=' ' && (unsigned char)ch<=177 && ch!=127 && ( i<width() || width()==0 ) )
                {
			s[i++] = ch;
			s[i] = 0;
			out( ch );
		}
                if( ch == '\n' || ch == '\r' || ch == '\0' )
                {
			out( '\n' );
			endinput();
			return;
		}
	}
}

void CC standardin::begininput(void)
{
        ;
}

void CC standardin::endinput(void)
{
        ;
}

standardin& CC standardin::setw( int w )
{
        fieldwidth = w;
        return *this;
}

int CC standardin::width()
{
        return fieldwidth;
}

standardin& CC standardin::setdefault( number def )
{
	num_default = def;
	return *this;
}

standardin& CC standardin::setmax( number max )
{
	num_max = max;
	return *this;
}

// standardin class

standardin& CC standardin::operator >> ( char& c )
{
	 c = get();
	 return *this;
}

standardin& CC standardin::operator >> ( char *s )
{
	getstr( s );
	return *this;
}

number CC standardin::readnum( number NUMBER_MAX )
{
        char ch, i = 0;
	number l = -1;
        int postfix = 0;
        char validchar = 0;

	if( NUMBER_MAX > num_max && num_max >= 0 ) NUMBER_MAX = num_max;

	begininput();

	do
	{
                if( postfix == 0 )
                        ch = toupper( get() );
                else
                {
                        postfix--;
                        ch = '0';
                }

                if( ch == '\b' && i > 0 )
                {
                        if( l > 9 )
                                l /= 10;
                        else
                                l = -1;
                        out( '\b' );
			out( ' ' );
                        out( '\b' );
                        i--;
                        validchar = 1;
                }
                else if( ch >= '0' && ch <= '9' )
                {
                        if( l == -1 )
                        {
                                number nl = ( ch - '0' );
                                if( nl > NUMBER_MAX ) nl = -1;
				if( nl >= 0 )
				{
					i++;
					out( ch );
					l = nl;
                                }
                        }
                        else
			{
                                if( l == 0 )
                                {
                                        out( '\b' );
					i--;
				}

				number nl = l * 10 + ( ch - '0' );
                                if( nl > NUMBER_MAX ) nl = -1;
				if( nl >= 0 )
				{
					i++;
					out( ch );
					l = nl;
				}
			}
                        validchar = 1;
		}
                else if( ch == '>' && num_max >= 0 )
                {
                        while( i > 0 )
                        {
                                out( '\b' );
                                out( ' ' );
                                out( '\b' );
                                i--;
                        }
			// count # digits in max
                        l = num_max;
                        for( i = 0; l > 0; i++ )
				l /= 10;
                        for( int j = i-1; j >= 0; j-- )
                        {
                                l = num_max;
                                for( int k = 0; k < j; k++ )
                                        l /= 10;
				out( '0' + number2long(l%10) );
                        }
                        l = num_max;
                        validchar = 1;
                }
                else if( ch == 'K' || ch == 'M' )
                {
                        if( validchar )
                        {
                                if( ch == 'K' ) postfix = 3;
                                if( ch == 'M' ) postfix = 6;
                        }
                }
                else
                        validchar = 0;

        } while( ch != '\n' && ch != '\r' && ch != '\0' );

        if( i == 0 )    l = -1;

        if( l == -1 )
        {
		char s[40];

		if( num_default == -1 )
			*s = 0;
		else
			number2ascii( num_default, s );

		for( int j = 0; s[j]; j++ )
			out( s[j] );

		l = num_default;
		num_default = -1;
		num_max = -1;

                endinput();
                out( '\n' );

		return l;
	}

	num_default = -1;
        num_max = -1;

        endinput();
        out( '\n' );

        return l;
}

standardin& CC standardin::operator >> ( long& l )
{
	l = number2long( readnum( LONG_MAX ) );
	return *this;
}

standardin& CC standardin::operator >> ( int& i )
{
	long l;

	l = number2long( readnum(INT_MAX) );
	if(l==-1)	i = -1;
	else		i = (int)l;

	return *this;
}

standardin& CC standardin::operator >> ( unsigned& i )
{
	i = (unsigned)( number2long( readnum(UINT_MAX) ) & 0xffff );
	return *this;
}

standardin& CC standardin::operator >> ( unsigned char& i )
{
	i = number2long( readnum(UCHAR_MAX) ) & 0xff;
	return *this;
}

// LineBuffer class
LineBuffer::LineBuffer( int w )
{
	if( w > 0 )
        {
                buf = new char[w+2];
                fg = new int[w+2];
                bg = new int[w+2];
        }
        else
        {
                buf = 0;
                fg = 0;
                bg = 0;
        }

	bufsize = linewidth = w;

	if( buf )       buf[0] = 0;
	bufpos = 0;
}

LineBuffer::LineBuffer( const LineBuffer& b )
{
	copy( b );
}

LineBuffer::~LineBuffer()
{
	kill();
}

LineBuffer& LineBuffer::operator = ( const LineBuffer& b )
{
	kill();
	copy( b );
	return *this;
}

void LineBuffer::copy( const LineBuffer& b )
{
	bufsize = linewidth = b.linewidth;
	if( linewidth > 0 )
	{
		buf = new char[linewidth+2];
		fg = new int[linewidth+2];
                bg = new int[linewidth+2];
        }
        else
        {
		buf = 0;
		fg = 0;
                bg = 0;
        }

	if( buf )
	{
                strcpy( buf, b.buf );
                bufpos = b.bufpos;
        }
        else
                bufpos = 0;

	if( fg )
		for( int i = 0; i < bufsize+2; i++ )
			fg[i] = b.fg[i];
	if( bg )
		for( int i = 0; i < bufsize+2; i++ )
			bg[i] = b.bg[i];
}

void LineBuffer::kill()
{
	delete buf;
	delete bg;
	delete fg;
}

LineBuffer& LineBuffer::insert( char c, int f, int b )
{
        if( buf && bufpos <= linewidth )
        {
                fg[bufpos] = f;
                bg[bufpos] = b;
                buf[bufpos++] = c;
                buf[bufpos] = '\0';
        }
        return *this;
}

LineBuffer& LineBuffer::backspace()
{
        if( buf && bufpos > 0 )
                buf[--bufpos] = '\0';
        return *this;
}

LineBuffer& LineBuffer::narrow( int w )
{
	if( w <= bufsize )
		linewidth = w;
	else
		linewidth = bufsize;
	return *this;
}

void LineBuffer::clear()
{
        bufpos = 0;
        if( buf ) buf[0] = '\0';
}

char LineBuffer::operator [] ( int index )
{
        if( buf && index >= 0 && index < linewidth )
                return buf[index];
        return 0;
}

int LineBuffer::fore( int index )
{
        if( fg && index >= 0 && index < linewidth )
                return fg[index];
        return 0;
}

int LineBuffer::back( int index )
{
        if( bg && index >= 0 && index < linewidth )
                return bg[index];
        return 0;
}

standardout& operator << ( standardout& out, const LineBuffer& b )
{
        if( !b.buf ) return out;
        for( int i = 0; i < b.bufpos; i++ )
        {
                if( b.fg && b.bg )
                        out << attr( b.fg[i], b.bg[i] );
                if( b.buf )
                        out << b.buf[i];
        }

        return out;
}

// standardout class

standardout::standardout( int newwidth ): buffer( newwidth )
{
        current_fore = 0;
	current_back = 0;
        new_fore = 0;
	new_back = 0;

	fieldwidth = 0;

        rawmode = 0;
        FilterANSI = 0;
        CommaFlag = 1;

        ESCflag = 0;
}

standardout::~standardout()
{
}

void CC standardout::beforeout()
{
}

void CC standardout::afterout()
{
}

standardout& CC standardout::operator << ( char c )
{
        beforeout();
        put( c );
        afterout();
        return *this;
}

standardout& CC standardout::setw( int w )
{ fieldwidth = w; return *this; }

static FilterFunction textfilter = 0;
FilterFunction SetTextFilter( FilterFunction f )
{
        FilterFunction old = textfilter;
        textfilter = f;
        return old;
}

standardout& CC standardout::operator << ( const char *s )
{
	int i = 0;

	if( !s )
		return (*this) << "(NULL POINTER!!!)";
        if( textfilter ) s = textfilter(s);
	beforeout();
	while( s[i] )
		put( s[i++] );
	for( ; i < width(); i++ )
		put( ' ' );
	afterout();

	return *this;
}

void standardout::writenum( number l )
{
	char s[80], i = 0, j;
	int sign = 0;

	if( l < 0 )
	{
		sign = -1;
		l = -l;
	}

	if( l == 0 )
	{
		s[0] = '0';
		i = 1;
	}
	else
	{
		while( l > 0 )
		{
			s[i++] = number2long( l % 10 ) + '0';
			l /= 10;
			if( i % 4 == 3 && CommaFlag )
				s[i++] = ',';
		}
                if( s[i-1] == ',' && CommaFlag )       s[--i] = 0;
                if( i == 5 && CommaFlag )
                {
			s[3] = s[4];
			s[4] = 0;
                        i--;
                }
        }

	if( sign )
		s[i++] = '-';

        beforeout();
	for( j = width(); j > i; j-- )
		put( ' ' );
	for( i--; i >= 0; i-- )
		put( s[i] );
        afterout();
}

standardout& CC standardout::operator << ( long l )
{
	writenum( l );
	return *this;
}

standardout& CC standardout::operator << ( int i )
{
	writenum( i );
	return *this;
}

standardout& CC standardout::operator << ( unsigned i )
{
	writenum( i );
	return *this;
}

standardout& CC standardout::operator << ( unsigned char i )
{
	return ( *this << (char)i );
}

void CC standardout::changecolor()
{
	const char *c = "04261537";

	if( FilterANSIMode() ) return;

	char s[15];
	int i = 2;
	s[0] = 27;
	s[1] = '[';

	if( new_back == -1 )
		new_back = current_back;

	if( ( current_fore >= 8 && new_fore < 8 ) || ( new_fore == 7 && new_back == 0 ) )
	{
		current_fore = 7;
		current_back = 0;
		s[i++] = '0';
		s[i++] = ';';
	}

	if( current_fore < 8 && new_fore >= 8 )
	{
		current_fore |= 8;
		s[i++] = '1';
		s[i++] = ';';
	}

	if( current_fore != new_fore )
	{
		current_fore = new_fore;
		s[i++] = '3';
		s[i++] = c[ new_fore & 7 ];
		s[i++] = ';';
	}

	if( current_back != new_back )
	{
		current_back = new_back;
		s[i++] = '4';
		s[i++] = c[ new_back & 7 ];
		s[i++] = ';';
	}

	s[i] = '\0';
	i--;
	s[i] = 'm';
	if( i > 1 )
		for( int j = 0; j <= i; j++ )
			_put( s[j] );
}

char CC standardout::put( char c )
{
	if( current_fore != new_fore || current_back != new_back )
		changecolor();

	if( rawmode )
	{
		if( c == '\n' )
			_put( '\r' );
                _put( c );
                return c;
        }

        if( ESCflag )
        {
		if( ( c >= 'A' && c <= 'Z' ) || ( c >= 'a' && c <= 'z' ) )
			ESCflag = 0;
                if( !FilterANSI )
                        _put( c );
		return c;
        }

	if( c == '\b' )
        {
                if( buffer.pos() > 0 || buffer.width() == 0 )
                {
                        buffer.backspace();
			_put( c );
			return c;
		}
		else
			return 0;
	}

	if( c == '\n' )
        {
                _put( '\r' );
                _put( '\n' );
                buffer.clear();

		return c;
	}

        if( c == 27 )
        {
		if( !FilterANSI )
                        _put( c );
		ESCflag = 1;
		return c;
	}

	_put( c );
	if( !iscntrl( (unsigned char)c ) )
                buffer.insert( c, current_fore, current_back );

        if( buffer.pos() >= buffer.width() && buffer.width() > 0 )
        {
                int i = buffer.pos();

                while( !isspace( (unsigned char)buffer[i] ) && i > buffer.width() * 3 / 4 )
			i--;

                if( i > buffer.width() * 3 / 4 )
                {
			int j = ++i;

                        for( ; j < buffer.pos(); j++ )
                        {
				_put( '\b' );
				_put( ' ' );
				_put( '\b' );
			}
			_put( '\r' );
			_put( '\n' );

                        LineBuffer b = buffer;
                        buffer.clear();

                        for( j = 0; i < b.pos(); i++, j++ )
                        {
                                (*this) << attr( b.fore(i), b.back(i) ) << b[i];
                        }

			return c;
		}

                buffer.clear();
                _put('\r');
                _put('\n');
	}

	return c;
}

char CC standardout::_put( char c )
{
	return c;
}

void CC standardout::SetAttr( int f, int b )
{
        new_fore = f;
        if( b != -1 )
                new_back = b;
        else
                new_back = current_back;
}

// Color object system
CC attr::attr( int f, int b )
	:fore(f), back(b)
{
}

standardout& CC operator << ( standardout& out, attr& a )
{
	out.SetAttr( a.fore, a.back );
	return out;
}
