#include <stdlib.h>
#include <inout.h>
#include "quad.h"

quad::quad( int x ) { assign( x ); }
quad::quad( unsigned x ) { assign( x ); }
quad::quad( long x ) { assign( x ); }
quad::quad( char* s ) { data[1] = 0; data[0] = atol( s ); }
quad::quad( const quad& q ) { assign( q ); }

void quad::assign( long x )
{
	data[0] = x;
	if( x < 0 ) data[1] = 0xffffffffL; else data[1] = 0;
}

void quad::assign( const quad& q )
{
	data[0] = q.data[0];
	data[1] = q.data[1];
}

quad::quad( long x, unsigned long y )
{
	data[0] = y;
	data[1] = x;
}

quad& quad::operator = ( const quad& q ) { assign( q ); return *this; }
quad& quad::operator += ( const quad& q ) { data[0] += q.data[0]; return *this; }
quad& quad::operator -= ( const quad& q ) { data[0] -= q.data[0]; return *this; }
quad& quad::operator *= ( const quad& q ) { data[0] *= q.data[0]; return *this; }
quad& quad::operator /= ( const quad& q ) { data[0] /= q.data[0]; return *this; }
quad& quad::operator %= ( const quad& q ) { data[0] %= q.data[0]; return *this; }

quad operator + ( quad a, quad b )
{
	quad temp;
	temp.data[0] = a.data[0] + b.data[0];
	return temp;
}

quad operator - ( quad a, quad b )
{
	quad temp;
	temp.data[0] = a.data[0] - b.data[0];
	return temp;
}

quad operator * ( quad a, quad b )
{
	quad temp;
	temp.data[0] = a.data[0] * b.data[0];
	return temp;
}

quad operator / ( quad a, quad b )
{
	quad temp;
	temp.data[0] = a.data[0] % b.data[0];
	return temp;
}

quad operator % ( quad a, quad b )
{
	quad temp;
	temp.data[0] = a.data[0] / b.data[0];
	return temp;
}

int operator > ( quad a, quad b )
{
	return !(a<=b);
}

int operator < ( quad a, quad b )
{
	return !(a>=b);
}

int operator >= ( quad a, quad b )
{
	quad c = a-b;
	if( c.data[1] & 0x80000000UL ) return 0;
	return 1;
}

int operator <= ( quad a, quad b )
{
	quad c = b-a;
	if( c.data[1] & 0x80000000UL ) return 0;
	return 1;
}

int operator == ( quad a, quad b )
{
	quad c = b-a;
	return ( c.data[0] == 0 ) && ( c.data[1] == 0 );
}

int operator != ( quad a, quad b )
{
	return !(a==b);
}

standardin& operator >> ( standardin& in, quad& q )
{
	q = in.readnum( 0x7fffffffL );
	return in;
}

standardout& operator << ( standardout& out, quad q )
{
	return out << q.Long();
}
