#include <srinout.h>
#include <dos.h>
#include <finout.h>

#include "ansi.h"
#include "fossil.h"
#include "types.h"
#include "door.h"
#include "desqview.h"

#include <coninout.h>
#include <srparam.h>

const char *VERSION = "0.000";
unsigned BaudRate = 2400;
const char *DoorFileName = "DOORFILE.SR";

void titlescreen()
{
        int LogFileStatus = kout.GetLogFileOutput();
	int k = 1;

        kout.PutLogFileOutput( 0 );             // don't send the title to
						// the log file

	sout.Clear();
        sout.NoCursor();

	if( Ansi )
		kout << "\033[0m\033[2J";
	else
		kout << "\n\n\n\n\n\n\n\n";

	if( IBMCharacters && Ansi )
	{
		int pl = PageLength;

		PageLength = 10000;
                k = !displayfile( "TITLE.ANS" );
		PageLength = pl;
		kout << attr(4) << '' << attr(12) << '';
                kout << attr(14) << "??? " << attr(15) << VERSION;
		kout << attr(12) << '' << attr(4) << '' << aNormal;
		kout << "\nReleased on ";
		kout << attr(10) << __DATE__ << attr(2) << '' << __TIME__;
		kout << aNormal << '\n';
	}
	if( k )
	{
                int ki;

		line( 70, attr(2) );
		for( ki = 0; ki < 19; ki++ )    kout << ' ';
                kout << attr(10) << "Your new game" << VERSION << '\n';
                for( ki = 0; ki < 34; ki++ )    kout << ' ';
                kout << attr( 3) << "By\n";
                for( ki = 0; ki < 28; ki++ )    kout << ' ';
                kout << attr(11) << " Someone \n";
		for( ki = 0; ki < 18; ki++ )    kout << ' ';
		kout << attr( 3) << "Released on " << attr(7) << __DATE__ << attr(8) << "" << attr(15) << __TIME__ << '\n';
		line( 70, attr(2) );
	}

	pause();
	sout.Clear();

	kout.PutLogFileOutput( LogFileStatus );
}

static Resource rGameName( "StatusBar.Game.Name", "" );
void statusbar( const char *user, const char *username, char c )
{
	void ForceDisplayTime();
	int i;

	MINY = 2;
	byte x = sout.WhereX(), y = sout.WhereY();
        int x1, y1, x2, y2;
	sout.GetRegion( x1, y1, x2, y2 );
	sout.Region( 1, 1, 80, 1 );
	int oldcol = sout.GetAttr();

	sout.Clear();
	sout << attr(10,2) << " ";
        sout << attr(15,-1) << "??? " << VERSION;
	if( strlen( (const char *)rGameName ) > 0 )
		sout << ' ' << (const char *)rGameName;
	sout << attr(10,-1) << "  ";

	if( ComPort == 0 )
		sout << attr(11,-1) << "LOCAL ";
	else
	{
		sout << attr(10,-1) << "COM" << DOOR.ComPort() << ": " << DOOR.RealBaudRate();
		if( SRterminal )
			sout << '*';
		if( fossil.exists )
			sout << 'F';
	}
	sout.ClearEOL();

        sout.Region( 1, MAXY+1, 80, MAXY+1 );
	sout.Clear();
        sout << attr(11,-1) << ' ' << user << ' ';
	sout << attr(0,-1) << '';
        sout << attr(14,-1) << c;
	sout << attr(0,-1) << '';
        sout << attr(15,-1) << ' ';
	for( i = 0; sout.WhereX() < 66 && username[i]; i++ )
		sout << username[i];
	if( sout.WhereX() < 57 )
	{
                sout << attr(0,-1) << " ";
		sout << attr(10,-1) << "F1 = Help";
	}
	sout.ClearEOL();

	sout.Region( x1, y1, x2, y2 );
	sout.SetAttr( oldcol );
	sout.GotoXY( x, y );

	ForceDisplayTime();
}

void readdoorfile()
{
	char tempstring[256];

	// Check locked out user list
	{
		filein f( "LOCKOUT.USR" );

		while( !!f )
		{
			f >> tempstring;
			if( !stricmp( tempstring, DOOR ) )
			{
				if( !displayscreen( "LOCKOUT" ) )
					kout << "You are not to play this game.\n";
				exit( 1 );
			}
		}
	}

        // create a new user if necessary!
}

int displayscreen( const char* name )
{
	char ColFile[80];
	char TxtFile[80];
	strcpy( ColFile, name );
	strcat( ColFile, ".ANS" );
	strcpy( TxtFile, name );
	strcat( TxtFile, ".TXT" );

	int lines = PageLength;
	PageLength = 9999;
        int RawMode = kout.RawMode();
        kout.SetRawMode();

	if( Ansi && IBMCharacters )
		if( displayfile( ColFile ) )
		{
			PageLength = lines;
                        if( !RawMode ) kout.ResetRawMode();
                        return 1;
		}

        if( !RawMode ) kout.ResetRawMode();
        int status = displayfile( TxtFile );
	PageLength = lines;
        return status;
}

int CC yesno( const char *prompttext, int defaultval )
{
	extern int multitask();
	static char ch;
	int t, SaveLogFileOutput;

	kout.setw();
	kout << prompttext << "?  " << bold;
	kout << ( defaultval ? "Y/n" : "y/N" );
        kout << nobold << "  ";

	SaveLogFileOutput = kout.GetLogFileOutput();
	kout.PutLogFileOutput( 0 );

	do
	{
                kout << aNormal << ' ';
		t = 0;
		while( SpecialEffects && !kin.keyhit() && t < 20000 )
		{
			kout << attr( 11 ) << "\b<";
			multitask(); TimedDelay( 36 );
			kout << attr( 14 ) << "\bv";
			multitask(); TimedDelay( 36 );
			kout << attr( 10 ) << "\b>";
			multitask(); TimedDelay( 36 );
			kout << attr(  9 ) << "\b^";
			multitask(); TimedDelay( 36 );
			kout << "\b ";
			t++;
		}

                kout << '\b' << aCursor;
		kin >> ch;
		ch = toupper( ch );
		if( ch == '\r' )
		{
			if( defaultval )
				ch = 'Y';
			else
				ch = 'N';
                }
        } while( ch != 'Y' && ch != 'N' );

        kout.PutLogFileOutput( SaveLogFileOutput );

        if( ch == 'Y' )
                kout << "Yes";
        else
                kout << "No";
        kout << aNormal << "\n";

        return ( ch == 'Y' );
}

void GotoXY( int x, int y )
{
        if( !Ansi ) return;
        kout << "\033[" << y << ';' << x << 'H';
}

void ClrScr()
{
        if( !Ansi )     kout << (char)12;
        else            kout << "\033[0m\033[2J";
}

void ClrEol()
{
        if( !Ansi )     return;
        kout << "\033[K";
}

// Draw a line of ='s n characters long.
void CC line( int n, attr color )
{
        kout << color;
        for( int i = 0; i < n; i++ )
                kout << '';
        kout << aNormal << '\n';
}

