// Parameter reading
#pragma hdrstop
#include <string.h>
#include <ctype.h>
#include <dos.h>
#include <stdlib.h>

#include <finout.h>
#include "srparam.h"

//////////////////////////////////////////////////////////////////////////

int Resource::dirty = 0;
Resource* Resource::head = 0;

Resource::Resource( const char *s, const char *def )
{
	dirty = 1;

	next = head;
	head = this;

//	name = new char[ strlen( s ) + 1 ];
//      if( name ) strcpy( name, s );
	name = s;

	value = 0;
	set( def );
	initialized = 0;
}

Resource::Resource( const char *s, const long def )
{
	char a[64];

	dirty = 1;

	next = head;
	head = this;

//	name = new char[ strlen( s ) + 1 ];
//	if( name ) strcpy( name, s );
	name = s;

	value = 0;
	ltoa( def, a, 10 );
	set( a );
	initialized = 0;

	for( int i = 1; i < _argc; i++ )
	{
		int val = -1;
		char arg[256], *p = _argv[i];

		if( *p != getswitchar() && *p != '/' && *p != '-' )
			continue;

		strcpy( arg, _argv[i]+1 );
		for( p = arg; *p && *p != '='; p++ )
			;
		if( *p )
		{
			*p = 0;
			p++;
		}

		if( !stricmp( arg, s ) )
		{
			val = 1;
			if( *p == '0' || toupper( *p ) == 'F' || toupper( *p ) == 'N' )
				val = 0;
		}

		if( !strnicmp( arg, "NO", 2 ) && !stricmp( arg+2, s ) )
			val = 0;

		if( val != -1 )
		{
			arg[0] = val + '0';
			arg[1] = 0;
			set( arg );
			initialized = 1;
		}
	}
}

Resource::~Resource()
{
//        delete name;
        delete value;

	if( head == this )
		head = next;
	else
	{
		Resource *p = head;

		while( p )
		{
			if( p -> next == this )
			{
				p -> next = next;
				return;
			}

			p = p -> next;
		}
	}
}

long CC Resource::Long()
{
	if( dirty ) Read();

	if( value )
                return strtol( value, NULL, 0 );
	return 0;
}

CC Resource::operator const char *()
{
	if( dirty ) Read();

	return value;
}

void CC Resource::set( const char *newvalue )
{
        delete value;
	value = new char[ strlen( newvalue ) + 1 ];
	if( value ) strcpy( value, newvalue );
}

void Resource::Read()
{
        Read( "RESOURCE.DAT" );
        Read( "RESOURCE.DEF" );
}

void Resource::Read( const char *name )
{
        filein f( name );
	char s[256];

	dirty = 0;
	if( !f ) return;

	for(;;)
	{
		char *n, *v;

		f.setw( 255 );
		f >> s;
		f.setw();

		if( !f )	break;

                // "#EOF" stops processing
                if( !stricmp( s, "#EOF" ) )
                        break;

                // n = Name of Resource
		for( n = s; *n && isspace( *n ); n++ )
			;

		// Comment characters are { ';', '#', '%' }
		if( *n == ';' || *n == '#' || *n == '%' )
			continue;

		// v = Value of Resource
		for( v = n; *v && !isspace( *v ); v++ )
			;

		*v = 0;
		v++;
		for( ; *v && isspace( *v ); v++ )
			;

		if( *v == '"' )
		{
			v++;
			for( char *e = v; *e && *e != '"'; e++ )
				;
			*e = 0;
		}

		// Set all resources that need to be set
		Resource *p = head;
		while( p )
		{
			if( !stricmp( p -> name, n ) && !p -> initialized )
                        {
				p -> set( v );
                                p -> initialized = 1;
                        }
			p = p -> next;
		}
	}
}

int CC Resource::Boolean()
{
	if( dirty )
		Read();

        if( !value )
                return 0;

	if( atol( value ) != 0 )
		return 1;

	if( !stricmp( value, "true" ) )
		return 1;

	if( !stricmp( value, "t" ) )
		return 1;

	if( !stricmp( value, "on" ) )
		return 1;

	if( !stricmp( value, "yes" ) )
		return 1;

	return 0;
}

//////////////////////////////////////////////////////////////////////////

int CC Parameter( const char *s )
{
	for( int i = 1; i < _argc; i++ )
	{
		char *p = _argv[i];

		if( *p == getswitchar() || *p == '/' || *p == '-' )
			continue;

		if( !stricmp( _argv[i], s ) )
			return 1;
	}
	return 0;
}
